//===================================================================
//
// teno_rx.c (@haekim)                                                               
//
//===================================================================           
// Copyright 2004-2010, ETRI 
//===================================================================
#include "nos.h"


#define MY_ID		1
#define CHANNEL		26
#define PAN_ADDR	312
//#define MIN_PERMIT_ID	0
//#define MAX_PERMIT_ID	19


UINT16 rx_data[NWK_MAX_PAYLOAD_SIZE/sizeof(UINT16)];	//102 byte long
UINT16 tx_data[NWK_MAX_PAYLOAD_SIZE/sizeof(UINT16)];
INT8 input_str[6];

//Receives string and toggles LEDs.
void rx_callback(void)
{
	UINT16 rx_src_id, parent_id, dest_id;
	UINT8 rx_data_length, rx_port;
	led_toggle(3);
	teno_recv_from_nwk(&rx_src_id, &rx_port, &rx_data_length, rx_data, &parent_id, &dest_id);
	uart_printf("\nRX : %u(%u)", rx_src_id, rx_data[0]);
}


void task1(void* args)
{
	while (TRUE)
	{
		delay_ms(1);
	}
}

int main(void) 
{
	nos_init();
	led_on(1);
	uart_puts("\n\r*** Nano OS ***\n\r");

	// Initializing  [ Channel:0x0B~0x1A (11~26), PAN ID : 0x0000~0xfffE(0~65534), Node ID(MAC short address) : 0~65534] 
	teno_init(CHANNEL, PAN_ADDR, MY_ID);
	//teno_set_rx_range(MIN_PERMIT_ID, MAX_PERMIT_ID);
	teno_set_rx_cb(rx_callback);
	teno_role_as_sink();
	uart_printf("RF Channel : %d\nPAN address: %u\nID : %d\n", CHANNEL, PAN_ADDR, MY_ID);

	thread_create(task1, NULL, 0, PRIORITY_NORMAL);
	sched_start();

	return 0;
} // main
