//===================================================================
//
// Max payload, Extream data flow Test
// tx.c (@shert, @haekim)
//
//===================================================================
// Copyright 2004-2010, ETRI
//===================================================================

#include "nos.h"

NMAC_TX_INFO tx_info;	// Simple mac Tx information
UINT8 tx_payload[NMAC_MAX_PAYLOAD_SIZE];	// Simple mac max payload : 115 byte

int main (void)
{
   	UINT8 n;
	led_on(3);
	nos_init();
	led_on(4);
	
	uart_puts("\n\r*** Nano OS ***\n\r");
	led_on(1);
	tx_info.dest_addr = 0x5678; // destination node id = 0x5678 (B)
	tx_info.payload_length 	= NMAC_MAX_PAYLOAD_SIZE; //116
	tx_info.payload_ptr = tx_payload;

	// Write dummy data to tx_payload[1]~[115].
   	for (n = 0; n < NMAC_MAX_PAYLOAD_SIZE; n++) 
	{
		tx_payload[n] = n;
	}

	mac_init(0x1a, 0x2420, 0x1234);	// channel=26, PAN id = 0x2420, source node id = 0x1234 (A)
	//mac_set_rx_range(0x0000, 0xffff); // default (from mac_init)
	//mac_set_tx_power(31); //default
	//mac_rx_on();		// default : on (from mac_init)
						// ack packet can be received even if rf has been turned off.
	//nmac_set_rx_cb(void (*func)(void)); // default : NULL. RX interrupt callback function
	
   	while (TRUE) 
   	{
		led_toggle(2);		

		++tx_payload[0];
		// Sends packet. Requests autoack
		if (mac_tx(&tx_info))
		{
			uart_printf("\nTX (success): %u", n);
		}
		else
		{
			uart_printf("\n\tTX (fail) : %u", n);
		}

		++tx_payload[0];
		// Sends same packet but do not request autoack.
		mac_tx_noack(&tx_info);
		uart_printf("\n\t\tTX without ACK : %u", n);
	}
    	return 0;
} // main
