//========================================================================
// File		: hal.c 
// Author	: Youngbum Park (youngbumpark@gmail.com)
// Date		: 2008.08.08
// Description : hal layer process test (ADC)
//========================================================================
// Copyright 2008 - 2014, HCI Lab
//========================================================================

//-------------- Terminal setting -----------------------
// Data bit		: 8 bit
// Stop bit		: 1 bit
// Parity		: none
//-------------------------------------------------------

#include "nos.h"

#define ADC_V3			0
#define INTERRUPT_V3	1

void interrupt_callback_function(void)
{
	led_toggle(1);
	delay_us(1);
	led_toggle(2);
	uart_printf("Interrupt Service Routine\n");	
}

int main (void)
{
	/*
	nos_init();
	uart_printf("\n Octacomm Sensor Hardware Interface Board Test \n");
	hal_pport_init(INTERRUPT_V3);
	hal_interrupt_mask_setting(INTERRUPT_V3);
	hal_interrupt_enable_state_setting(INTERRUPT_V3, FALLING_EDGE);
	hal_register_interrupt_callback_func(INTERRUPT_V3, interrupt_callback_function);
	led_on(3);
	hal_pport_on(INTERRUPT_V3);
	uart_printf("ADC_V3 power ON\n");
	while (1);
	
	hal_pport_off(INTERRUPT_V3);
	*/

	nos_init();
	uart_printf("\n Octacomm Sensor Hardware Interface Board Test \n");
	led_on(3);
	re200b_init(INTERRUPT_V3);
	re200b_power_on(INTERRUPT_V3);

	//re200b_register_callback_func(INTERRUPT_V3, interrupt_callback_function);
	re200b_callback_test(INTERRUPT_V3, interrupt_callback_function);
	while(1);
	return 0;
}

